/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.GeometricCrop;


import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.geometries.interactiveGlyphs.InteractiveGlyph.GlyphType.*;
import org.visnow.vn.gui.widgets.RunButton;
import static org.visnow.vn.lib.basic.filters.GeometricCrop.GeometricCropShared.*;
import org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrange;
import org.visnow.vn.lib.utils.SwingInstancer;
import static org.visnow.vn.lib.utils.field.subset.GeometricSubsetParams.Depth.*;
import static org.visnow.vn.lib.utils.field.subset.GeometricSubsetParams.Position.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;
    private boolean regularInField = false;
    private int trueNSpace = -1;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
        maskButton.setVisible(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        geometryControlPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        fullyInButton = new javax.swing.JRadioButton();
        inButton = new javax.swing.JRadioButton();
        bdryButton = new javax.swing.JRadioButton();
        outButton = new javax.swing.JRadioButton();
        fullyOutButton = new javax.swing.JRadioButton();
        maskButton = new javax.swing.JRadioButton();
        fullyCleanButton = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        IndexCropButton = new javax.swing.JRadioButton();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        selectionTypePanel = new javax.swing.JPanel();
        boxButton = new javax.swing.JRadioButton();
        cmpButton1 = new javax.swing.JRadioButton();
        sphereButton = new javax.swing.JRadioButton();
        componentControlPanel = new javax.swing.JPanel();
        componentSubrangeUI = new org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrangeUI();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();

        setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        setMinimumSize(new java.awt.Dimension(180, 500));
        setPreferredSize(new java.awt.Dimension(200, 600));
        setRequestFocusEnabled(false);
        setLayout(new java.awt.GridBagLayout());

        geometryControlPanel.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(geometryControlPanel, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        buttonGroup2.add(fullyInButton);
        fullyInButton.setSelected(true);
        fullyInButton.setText("fully inside");
        fullyInButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fullyInButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(fullyInButton, gridBagConstraints);

        buttonGroup2.add(inButton);
        inButton.setText("touching inside");
        inButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                inButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(inButton, gridBagConstraints);

        buttonGroup2.add(bdryButton);
        bdryButton.setText("on boundary");
        bdryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bdryButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(bdryButton, gridBagConstraints);

        buttonGroup2.add(outButton);
        outButton.setText("touching outside");
        outButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                outButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(outButton, gridBagConstraints);

        buttonGroup2.add(fullyOutButton);
        fullyOutButton.setText("fully outside");
        fullyOutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fullyOutButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(fullyOutButton, gridBagConstraints);

        buttonGroup3.add(maskButton);
        maskButton.setLabel("<html>mask out nodes<p>outside selected<p>area\n");
        maskButton.setMaximumSize(new java.awt.Dimension(2147483647, 60));
        maskButton.setMinimumSize(new java.awt.Dimension(93, 60));
        maskButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                maskButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(maskButton, gridBagConstraints);

        buttonGroup3.add(fullyCleanButton);
        fullyCleanButton.setSelected(true);
        fullyCleanButton.setText("<html>remove nodes<p>outside selected<p>area");
        fullyCleanButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fullyCleanButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(fullyCleanButton, gridBagConstraints);

        jLabel1.setForeground(new java.awt.Color(153, 0, 51));
        jLabel1.setInheritsPopupMenu(false);
        jLabel1.setMaximumSize(new java.awt.Dimension(56, 40));
        jLabel1.setMinimumSize(new java.awt.Dimension(56, 40));
        jLabel1.setPreferredSize(new java.awt.Dimension(56, 40));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 12, 0, 0);
        jPanel1.add(jLabel1, gridBagConstraints);

        buttonGroup3.add(IndexCropButton);
        IndexCropButton.setText("regular field crop");
        IndexCropButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                IndexCropButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(IndexCropButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(jPanel1, gridBagConstraints);

        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                runButtonUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        add(runButton, gridBagConstraints);

        selectionTypePanel.setLayout(new java.awt.GridLayout(2, 0));

        buttonGroup1.add(boxButton);
        boxButton.setText("box");
        boxButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boxButtonActionPerformed(evt);
            }
        });
        selectionTypePanel.add(boxButton);

        buttonGroup1.add(cmpButton1);
        cmpButton1.setText("component");
        cmpButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmpButton1ActionPerformed(evt);
            }
        });
        selectionTypePanel.add(cmpButton1);

        buttonGroup1.add(sphereButton);
        sphereButton.setText("sphere");
        sphereButton.setActionCommand("<html>create point cells <p>from orphaned nodes</html>");
        sphereButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sphereButtonActionPerformed(evt);
            }
        });
        selectionTypePanel.add(sphereButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(selectionTypePanel, gridBagConstraints);

        componentControlPanel.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        componentControlPanel.add(componentSubrangeUI, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        componentControlPanel.add(jPanel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(componentControlPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jPanel3, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void boxButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boxButtonActionPerformed
        geometryType();
    }//GEN-LAST:event_boxButtonActionPerformed

    private void sphereButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sphereButtonActionPerformed
        geometryType();
    }//GEN-LAST:event_sphereButtonActionPerformed

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButtonUserChangeAction
    {//GEN-HEADEREND:event_runButtonUserChangeAction
        parameters.set(RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

    private void fullyInButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fullyInButtonActionPerformed
    {//GEN-HEADEREND:event_fullyInButtonActionPerformed
        extent();
    }//GEN-LAST:event_fullyInButtonActionPerformed

    private void inButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_inButtonActionPerformed
    {//GEN-HEADEREND:event_inButtonActionPerformed
        extent();
    }//GEN-LAST:event_inButtonActionPerformed

    private void bdryButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_bdryButtonActionPerformed
    {//GEN-HEADEREND:event_bdryButtonActionPerformed
        extent();
    }//GEN-LAST:event_bdryButtonActionPerformed

    private void outButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_outButtonActionPerformed
    {//GEN-HEADEREND:event_outButtonActionPerformed
        extent();
    }//GEN-LAST:event_outButtonActionPerformed

    private void fullyOutButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fullyOutButtonActionPerformed
    {//GEN-HEADEREND:event_fullyOutButtonActionPerformed
        extent();
    }//GEN-LAST:event_fullyOutButtonActionPerformed

    private void maskButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_maskButtonActionPerformed
    {//GEN-HEADEREND:event_maskButtonActionPerformed
        depth();
    }//GEN-LAST:event_maskButtonActionPerformed

    private void fullyCleanButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fullyCleanButtonActionPerformed
    {//GEN-HEADEREND:event_fullyCleanButtonActionPerformed
        depth();
    }//GEN-LAST:event_fullyCleanButtonActionPerformed

    private void cmpButton1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cmpButton1ActionPerformed
    {//GEN-HEADEREND:event_cmpButton1ActionPerformed
        geometryType();
    }//GEN-LAST:event_cmpButton1ActionPerformed

    private void IndexCropButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_IndexCropButtonActionPerformed
    {//GEN-HEADEREND:event_IndexCropButtonActionPerformed
        depth();
    }//GEN-LAST:event_IndexCropButtonActionPerformed

    private void extent()
    {
        if (fullyInButton.isSelected())
            parameters.set(POSITION, FULLY_IN);
        if (inButton.isSelected())
            parameters.set(POSITION, IN);
        if (bdryButton.isSelected())
            parameters.set(POSITION, BOUNDARY);
        if (outButton.isSelected())
            parameters.set(POSITION, OUT);
        if (fullyOutButton.isSelected())
            parameters.set(POSITION, FULLY_OUT);
        armRunButton();
    }
    
    private void geometryType()
    {
        if (boxButton.isSelected())
            parameters.set(TYPE, trueNSpace != 2 ? BOX : RECTANGLE);
        if (sphereButton.isSelected())
            parameters.set(TYPE, trueNSpace != 2 ? SPHERE : CIRCLE);
        parameters.set(GEOMETRIC, !cmpButton1.isSelected());
        geometryControlPanel.setVisible(parameters.get(GEOMETRIC));
        componentControlPanel.setVisible(!parameters.get(GEOMETRIC));
        armRunButton();
    }
    
    private void depth()
    {
        if (maskButton.isSelected())
           parameters.set(DEPTH, MASK); 
        if (fullyCleanButton.isSelected())
           parameters.set(DEPTH, FULL); 
        if (IndexCropButton.isSelected())
           parameters.set(DEPTH, INDEX); 
        armRunButton();
    }

    /**
     * @param params the params to set
     */

    void setParameters(Parameters parameters) 
    {
        this.parameters = parameters;
    }
    
    void setRange(ComponentSubrange range)
    {
        componentSubrangeUI.setComponentValue(range);
        range.addChangeListener(new ChangeListener(){
            @Override
            public void stateChanged(ChangeEvent e)
            {
                SwingInstancer.swingRunLater(() -> {
                    armRunButton();
                });

            }
        });
    }
    
    void setInFieldTrueNSpace(int trueNSpace)
    {
        this.trueNSpace = trueNSpace;
        if (trueNSpace == 3) {
            boxButton.setText("box");
            sphereButton.setText("sphere");
        }
        else {
            boxButton.setText("rectangle");
            sphereButton.setText("circle");
        }
        geometryType();
    }
    
    void setRegularInField(boolean regular)
    {
        if (regular == regularInField)
            return;
        regularInField = regular;
        IndexCropButton.setVisible(regular);
        if (!regular && IndexCropButton.isSelected()) {
            fullyCleanButton.setSelected(true);
            parameters.set(DEPTH, FULL); 
            armRunButton();
        }
    }
    
    void addUI(JPanel ui)
    {
        geometryControlPanel.add(ui, BorderLayout.CENTER);
    }
    
    void clearUI()
    {
        geometryControlPanel.removeAll();
    }

    void displayWarning(boolean emptyOutput)
    {
        jLabel1.setText(
                emptyOutput ? "<html>No cell satisfies given conditions<p>Last outfield is retained</html>"
                        : "");
    }
    
    void armRunButton()
    {
        runButton.setPendingIfNoAuto();
    }
    
    void disarmRunButton()
    {
        runButton.clearPending();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton IndexCropButton;
    private javax.swing.JRadioButton bdryButton;
    private javax.swing.JRadioButton boxButton;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.JRadioButton cmpButton1;
    private javax.swing.JPanel componentControlPanel;
    private org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrangeUI componentSubrangeUI;
    private javax.swing.JRadioButton fullyCleanButton;
    private javax.swing.JRadioButton fullyInButton;
    private javax.swing.JRadioButton fullyOutButton;
    private javax.swing.JPanel geometryControlPanel;
    private javax.swing.JRadioButton inButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JRadioButton maskButton;
    private javax.swing.JRadioButton outButton;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    private javax.swing.JPanel selectionTypePanel;
    private javax.swing.JRadioButton sphereButton;
    // End of variables declaration//GEN-END:variables

}
